Compute InScopeSet in substInteractiveContext
ClosedPublic

Authored by niteria on Apr 7 2017, 2:04 AM.

Details

Summary

It doesn't look like we keep any sets of free variables
of the types of Ids handy, so we just have to build them
when doing a substitution.

Test Plan

buildbot + run testsuite with debug

Diff Detail

Repository
rGHC Glasgow Haskell Compiler
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
niteria created this revision.Apr 7 2017, 2:04 AM
simonpj accepted this revision.Apr 7 2017, 5:43 AM

Yes, looks right. Worth pointing out (in a comment) that variables in the interactive context *can* mention free type variables because of the runtime debugger. (Otherwise you'd expect all variables bound in the interactive context to be closed.) Indeed all uses of substInteractiveContext are in connection with the debugger.

This revision is now accepted and ready to land.Apr 7 2017, 5:43 AM
niteria planned changes to this revision.Apr 10 2017, 1:12 PM

I will come back to this and add a comment.

austin resigned from this revision.Nov 9 2017, 11:36 AM
niteria updated this revision to Diff 14980.Dec 26 2017, 6:23 AM

adding a comment

This revision is now accepted and ready to land.Dec 26 2017, 6:23 AM
This revision was automatically updated to reflect the committed changes.